<template>
  <v-form
      ref="offerForm"
      @submit.prevent=""
  >

    <p>Buy Prints</p>
    <v-select
        v-model="form.prints"
        :items="printsArr"
        label="Prints"
        filled
        outlined
        v-validate="'required'"
        data-vv-name="prints"
        :error-messages="errors.collect('prints')"
    ></v-select>
    <v-text-field
        v-model="form.count_prints"
        class="mb-4"
        type="number"
        outlined
        label="count prints"
        v-validate="'required'"
        data-vv-name="count_prints"
        :error-messages="errors.collect('count_prints')"
    ></v-text-field>
    <div v-if="this.cardNumber">
      <v-btn @click="confirmPayBuyOffer" class="saved-card mb-6" :loading="loading" width="100%"
      >
        <b>Use this card {{ this.cardNumber }}</b>
      </v-btn>
      <div>
        <v-btn v-if="this.cardNumber" @click="formWithNewCardIsShown = !formWithNewCardIsShown "
               class="saved-card mb-10" width="100%">
          <b>Use new card</b>
          <v-icon class="pl-4">{{ `mdi-arrow-${formWithNewCardIsShown ? 'up' : 'down'}` }}</v-icon>
        </v-btn>
      </div>
    </div>
    <div v-show="!this.cardNumber || formWithNewCardIsShown">
      <v-text-field
          v-model="form.name_on_card"
          class="mb-4"
          outlined
          label="Name on Card"
          v-validate="'required'"
          data-vv-name="name card"
          :error-messages="errors.collect('name card')"
      ></v-text-field>
      <v-row no-gutters>
        <v-col cols="10">
          <v-text-field
              v-model="cardNumberWithMask"
              class="mb-4"
              outlined
              label="Card Number"
              v-mask="'#### #### #### ####'"
              v-validate="'required|min:18|max:19'"
              data-vv-name="card number"
              :error-messages="errors.collect('card number')"
              @blur="form.card_number = cardNumberWithMask.replace(/\s+/g, '')"
          ></v-text-field>
        </v-col>
        <v-col>
          <v-icon
              large
              class="ml-3 mt-3"
          >
            mdi-credit-card-check-outline
          </v-icon>
        </v-col>
      </v-row>
      <v-row>
        <v-col cols="6" sm="4">
          <v-select
              v-model="form.date_mm"
              :items="days"
              label="Month"
              filled
              outlined
              v-validate="'required'"
              data-vv-name="Month"
              :error-messages="errors.collect('Month')"
          ></v-select>
        </v-col>
        <v-col cols="6" sm="4">
          <v-select
              v-model="selectedYear"
              :items="years"
              label="Year"
              filled
              outlined
              @input="selectYearHandler"
              v-validate="'required'"
              data-vv-name="Year"
              :error-messages="errors.collect('Year')"
          ></v-select>
        </v-col>
        <v-col cols="12" sm="4">
          <v-text-field
              v-model="form.cvv"
              class="mb-4"
              outlined
              v-mask="'####'"
              v-validate="'required|numeric|min:3|max:4'"
              data-vv-name="cvv"
              :error-messages="errors.collect('cvv')"
          ></v-text-field>
        </v-col>
      </v-row>
      <v-row no-gutters>
        <v-checkbox
            class="mt-0 ml-auto"
            v-model="form.is_save_card"
            label="Save this card ?"
        ></v-checkbox>
      </v-row>
      <v-btn
          :class="{'full-width-btn': $vuetify.breakpoint.xsOnly}"
          class="mt-2"
          type="submit"
          color="primary"
          @click="buyOffer(false)"
          :loading="loading"
      >Buy Prints
      </v-btn>
    </div>
    <v-dialog
        v-model="dialog"
        max-width="290"
    >
      <ConfirmPay @closeDialog="closeDialog" @confirmOffer="buyOffer(true)"/>
    </v-dialog>
  </v-form>
</template>

<script>
import {mapActions, mapState} from "vuex";
import ConfirmPay from "../common/modal/ConfirmPay";

export default {
  name: "UpdateBalanceForm",
  components: {ConfirmPay},
  props: {
    prints: {
      type: Array
    }
  },
  data: () => ({
    formWithNewCardIsShown: false,
    form: {
      name_on_card: '',
      card_number: '',
      date_mm: '',
      date_yy: '',
      cvv: '',
      offer_name: '',
      use_saved_card: '',

      is_save_card: '',

      prints: '',
      count_prints: '',
    },
    cardNumberWithMask: '',
    days: ['01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12'],
    years: ['2021', '2022', '2023', '2024', '2025', '2026', '2027', '2028'],
    selectedYear: '',
    loading: false,
    dialog: false
  }),
  computed: {
    ...mapState(['username', 'cardNumber', 'currentTime', 'userId']),
    offersNameWithCost() {
      return this.offers.map(item => {
        return {
          name: item.Name,
          nameWithCost: `${item.Name} (${item.CostPrice} $)`
        }
      })
    },
    printsArr() {
      return this.prints.map(item => item.Name)
    }
  },
  methods: {
    ...mapActions(['setNotification', 'setBalance', "setCardNumber"]),
    confirmPayBuyOffer() {
      const isValid = (this.$validator.validate('prints') && this.$validator.validate('count_prints'))
      console.log(isValid);
      if (isValid) {
        this.dialog = true
      }
    },
    closeDialog() {
      this.dialog = false
    },
    async buyOffer(isSavedCard) {
      try {
        const payload = new FormData()
        if (isSavedCard) {
          this.form.use_saved_card = true
        }

        for (const key in this.form) {
          payload.append(key, this.form[key])
        }

        const isValid = !isSavedCard ? await this.$validator.validateAll() : true
        if (isValid) {
          this.loading = true

          const response = await this.$axios.post(`api/users/buyPrint`, payload)

          if (response.status === 200) {
            this.clearForm()
            this.setNotification({
              show: true,
              type: 'success',
              message: response.data.message
            })
            this.$eventBus.$emit('updateUser', response.data.user);
            this.setBalance({
              balance: response.data.user.balance
            })
            this.$eventBus.$emit('updateUser', response.data.user)
            this.setCardNumber({
              cardNumber: response.data.user.cardNumber
            })
          }
          this.$refs.offerForm.reset()
          this.$emit('closeDialog')
        }
      } catch (error) {
        console.log(error)
      } finally {
        this.loading = false
      }
    },
    async fetchOffers() {
      try {
        const response = await this.$axios.get('/api/sloffers')

        if (response.status === 200) {
          this.offers = response.data
        }
      } catch (error) {
        console.log(error)
      }
    },
    clearForm() {
      Object.keys(this.form).forEach(key => this.form[key] = null)
      this.form.offer_name = null
      this.cardNumberWithMask = null
    },
    selectYearHandler() {
      this.form.date_yy = this.selectedYear?.toString().slice(-2)
    },
  },
}
</script>

<style scoped>

</style>
